<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <title>CS 1653 Project P1 Writeup</title>
  <style>

/* In this section, you may add CSS styling if desired */
header {
  text-align: center;
}

body {
  margin: 40px auto;
  max-width: 61.8034%;
  line-height: 1.6;
  font-size: 18px;
  color: #444;
  padding: 0 10px;
}

/* END CHANGES HERE */
  </style>
  <body>
    <header>
      <h1>CS 1653 Project P1 Writeup</h1>
      <h2>
         <p>Christopher Constantino &lt;email redacted&gt;</p>
         <p>Jordon Rapoport         &lt;email redacted&gt;</p>
         <p>Michael Stoltz          &lt;email redacted&gt;</p>
      </h2>
    </header>

<section id="properties">
<h2>1. Security Properties</h2>

<ul>
<li><p><b>Closed System:</b>
    This property refers to authorized members within a group. Anyone not
authorized to be in such a group will not have the ability to read, modify,
delete, etc. any of the content within the group. This is important so that
files can be secure and kept private from those not within the group. This
property assumes various measures are taken to ensure account safety such as
users with complex passwords that are at the very least hashed and salted upon
registrationThis property refers to authorized members within a group. Anyone
not authorized to be in such a group will not have the ability to read, modify,
delete, etc. any of the content within the group. This is important so that
files can be secure and kept private from those not within the group. This
property assumes various measures are taken to ensure account safety such as
users with complex passwords that are at the very least hashed and salted upon
registration.
</p></li>
<li><p><b>Correct Multitasking:</b>
    The actions of one user should not trample the actions of another user. For
example, the system should forbid the deletion or overwriting of files that are
being actively downloaded. downloaded. This is important to ensure the user
downloading the file is able to get the entire file they intended to download
without it being changed to a different file or deleted during the download.
</p></li>
<li><p><b>Data Confirmation:</b>
    The file downloaded by a user is the whole intended file that was meant to
be downloaded. It was not altered on its way to the user in any way, maliciously
or accidentally. This is important to protect the user, and guarantee they are
downloading what they intended.
</p></li>
<li><p><b>Distributable Revocation Process:</b>
    If a component is compromised, it must be possible to revoke its privileges
across the entire system. This introduces a potential vulnerability in that, if
the mechanisms to implement this are compromised, the entire network is exposed
to a privilege-revoking rampage. Compare and contrast possible conflicts with
Fault Tolerance. See also Compromise Recording in SS75 p. 1283.
</p></li>
<li><p><b>Economy of Design:</b>  See Economy of Mechanism.
</p></li>
<li><p><b>Economy of Mechanism:</b>
    A.k.a. Keep It Simple, Stupid. The probability of bugs emerging is
proportional to the complexity of the system, so a simpler system has fewer bugs
and is therefore more secure. This principle is related to Occam's razor, which
states that a philosophy or theory should not enumerate assumptions beyond those
that are strictly necessary; the same rule of thumb holds true when designing
systems or writing code. Because mechanism is a subset of design, there is a
corollary property of Economy of Design. (SS75 p. 1282).
</p></li>
<li><p><b>Fault Tolerance:</b>
    A break in security in one part of the system must not propagate to other
parts of the system. This means that if a user's password is compromised or
a bug is found in the group server, client, or file server processes, the
other components should remain secure. In particular, files should be the last
possible thing to be compromised, because that is the worst case scenario for a
leak. Cf. Distributable Revocation.
</p></li>
<li><p><b>File Distinction:</b>
    Where files are stored and how much space they take up should be secure and
abstracted from the user. When a file is downloaded only that specific section
of data is returned, the user cannot maliciously specifiy a larger amount of
data to be returned in order to gather data not intended to be served with that
file.
</p></li>
<li><p><b>Least Privilege:</b>
    Every program and every user of the system should operate using the least
set of privileges necessary. Relating closely to the permissions property, this
ensures that by default users are given the least amount of privileges and
only through manual and conscientious change should a user be granted higher
privilege. Without this requirement, users might be given privileges that they
should not have. (SS75 p. 1282).
</p></li>
<li><p><b>Minimum Window of Opportunity:</b>
    Sensitive data are kept encrypted unless access is specifically needed at
that moment. The benefit of this property is that there are fewer scenarios
where bugs can arise that expose the plaintext. This also decreases the chance
of something uncontrollable (e.g. a power outage) from leaving plaintext
vulnerable. See also the Minimum Privilege Necessary property.
</p></li> <li><p><b>Modularity:</b>
    Each component of the system (e.g. user-facing client application, server
process, etc.) should effectively form a "boundary" around itself, and any data
transmitted across these boundaries should be encrypted (end-to-end encryption).
See also Economy of Design/Mechanism, Fault Tolerance.
</p></li>
<li><p><b>Open Design:</b>
    The design of the file sharing system should be open. An open design would
allow skeptical users to see design flaws, as well as permit and encourage an
open review of the software. Over a long enough timeline, hackers can and will
exploit design flaws and this is encouraged by keeping the design a secret. An
open design allows others to check for flaws and to continually be working to
improve the software.
</p></li>
<li><p><b>Permissions:</b>
    The ability to create/delete a user and/or a group should depend on the
proper permissions of the user trying to perform such an action. Users should
have various levels of permissions that state just how much control they are
actually allowed. This is important to ensure that members of a group don't have
the same autonomy as an administrator if such autonomy is not desired. Without
this requirement any user could add or delete anybody he wants.
</p></li>
<li><p><b>Psychological Acceptability:</b>
    Security mechanisms should be user friendly to promote and facilitate their
use. Where possible, transparency of security mechanisms is preferred to allow
the least minimal obstruction to a user. This is an important measure because
any security property that seems complex might be turned off by a user. See also
Transparency. (SS75 p. 1283.)
</p></li>
<li><p><b>Randomization:</b>
    Patterns in program execution should be avoided. An example of a type of
system with this property are operating systems which randomize address space
layout. Even something as simple as recording the sounds made by the CPU fan can
be used by an attacker to gain knowledge about the system.
</p></li>
<li><p><b>Transparency:</b>
    The user interface must not lie to the user. Doing so could cause the user
to perform actions that he believes are secure but which are actually not. It
also makes bug reporting and debugging more difficult, which is a security risk.
See also Psychological Acceptability. Additionally, code should be explicit
and up front about its assumptions. Whatever the developer had in mind when he
was writing it should be on record and available for auditing and reviewing.
Requiring the code reviewer to rediscover something that was known at one point
is error-prone and inefficient.
</p></li>
<li><p><b>User Privacy:</b>
    Personally identifying user information should be protected. This is
derived partially from Psychological Acceptability (the typical user will be
security-conscious and thus opposed to leaking information) and partially from
Economy of Design (the system has no reason to make user information public).
</p></li>
<li><p><b>Verified Identity:</b>
    Any and all data transmitted must come from a known identity associated
with, for example, the specific file server that holds a file. This protects
against having a file server's contents tampered with and from in-transit
tampering.
</p></li>
<li><p><b>Whole File Manipulation:</b>
    When a file is uploaded, deleted, or overwritten, the entire file is
modified. Small sections of the files cannot be overwritten or deleted on their
own. This is important to prevent file corruption issues and to make sure saved
files are not tampered with where they are stored.
</p></li>
</ul>
</section>

<section id="models">
<h2>2. Threat Models</h2>

<h3>1. System Model</h3>

<h4>Threat Model 1</h4>

<p>
One possible deployment would be in an office setting for the purpose of
enabling file exchange or distribution between different groups of employees.
For example, the HR department could share employee handbooks and request forms.
The threat models in this instance are very similar to those seen with FTP/SFTP
or SSH.
</p>

<h4>Threat Model 2</h4>

<p>
Another possible deployment would be as a personal network file storage system,
akin to Dropbox or Google Drive but without making use of any sharing/multiuser
features.
</p>

<h3>2. Trust Assumptions</h3>

<p>
A certain degree of trust in the users is necessary, because there is no way
for the software to protect against externalities such as users poorly handling
their passwords, files, etc. Inside the system, however, security should
never be left up to user "discipline." The system cannot in general guarantee
semantic integrity, e.g. making sure that a file "needed" by User A is not
deleted by some User B who has the permissions to delete it unless the user
manually establishes ownership of the file (which should be possible, e.g. by
establishing a single-user group that has access to a particular file). In other
words, members with the appropriate permissions to modify, delete, tamper with
sensitive group information or files are expected to do so in accordance with
the group's policies, not all of which can be known (and therefore managed) by
the system.
</p>

<h3>3. Security Properties</h3>

<ul>
<li><b>Closed System</b> - Only the members of a group are able to perform actions which require group membership. This is necessary for basic operation and so applies to all threat models.</li>
<li><b>Correct Multitasking</b> - That the actions of one user do not interfere with the actions of another. This is necessary for cases like our first model to prevent attackers or even normal users from clobbering data.</li>
<li><b>Data Confirmation</b> - The system ensures data integrity when possible and informs users of losses in integrity should they occur. This is necessary to protect against insertion or deletion attacks.</li>
<li><b>Distributable Revocation Process</b> - Permissions can be revoked from actors with compromised identities. For example, if a user's private key is compromised, other users must be aware that the digital signatures made with that key are no longer valid.</li>
<li><b>Economy of Mechanism and Design</b> - The system should contain what is necessary to be correct, but nothing more.</li>
<li><b>Fault Tolerance</b> - The system as a whole is tolerant to faults occurring in specific parts.</li>
<li><b>File Distinction</b> - Files, like users, have associated identities that the system verifies.</li>
<li><b>Least Privilege</b> - By default, users operate with the least amount of privilege necessary.</li>
<li><b>Minimum Window of Opportunity</b> - The system should expose itself to attacks as little as possible.</li>
<li><b>Modularity</b> - The system is modular in design and implementation.</li>
<li><b>Open Design</b> - The source code is viewable by users, assuaging skeptics and allowing for more people to improve the underlying software.</li>
<li><b>Permissions</b> - Users have various levels of permissions to change items in the group.</li>
<li><b>Psychological Acceptability</b> - Security mechanisms are user-friendly and transparent so that they can be correctly employed by the users.</li>
<li><b>Randomization</b> - The system does not exhibit patterns in its execution that expose information to attackers.</li>
<li><b>Transparency</b> - The system does not lie to its users via the UI or to its developers via documentation, comments, indecipherable code, etc.</li>
<li><b>User Privacy</b> - User information not required for correct operation is not put at risk.</li>
<li><b>Verified Identity</b> - The identities of actors in the system are known to the system. This is necessary for basic operation.</li>
<li><b>Whole File Manipulation</b> - Operations on files are atomic, so (for example) interrupting a file operation will not leave a file in an in-between state.</li>
</ul>
</section>

<section id="references">
<h2>3. References</h2>

<p>
<b>[SS75]</b> Jerome H. Saltzer and Michael D. Schroeder, The Protection of
Information in Computer Systems, Proceedings of the IEEE 63(9): 1278–1308,
Sep. 1975.
</p>
</section>

<!---
Operations:
* Create/delete user
* Create/delete group
* Add/remove user u to/from group g
* Upload/overwrite file f to be shared with members of group g
* Download file f
* Delete file f
-->
  </body>
</html>
